//+------------------------------------------------------------------+
//|                             ChartBackgroundColorByPrice_BTEv.mq5 |
//|                                          Copyright 2022 mql5.com |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2022 mql5.com"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_plots 0
#property indicator_chart_window

input ENUM_TIMEFRAMES    TimeFrame          = PERIOD_D1;
input color              BullishColor       = clrDarkGreen;
input color              BearishColor       = clrMaroon; 
input uint               Bar                = 0; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
               double Bid = SymbolInfoDouble(_Symbol,SYMBOL_BID);
               double Ask = SymbolInfoDouble(_Symbol,SYMBOL_ASK);
                if(Bid>iOpen(_Symbol,TimeFrame,Bar))
                ChartSetInteger(0,CHART_COLOR_BACKGROUND,BullishColor);
                if(Bid<=iOpen(_Symbol,TimeFrame,Bar))
                ChartSetInteger(0,CHART_COLOR_BACKGROUND,BearishColor);
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
